<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { computed, inject } from 'vue';
import { useI18n } from 'vue-i18n';
import { storeToRefs } from 'pinia';
import { useCreateStore } from '@/stores/create';
import Range from "@/components/general/form/Range.vue";
import BoxSelector from "@/components/general/form/BoxSelector.vue";
import { itemEnum } from '@/enums/enums';
import RadioButtonsGroup from '@/components/general/form/RadioButtonsGroup.vue';
import Button from '@/components/general/Button.vue';
import PreviewLine from '@/components/general/PreviewLine.vue';

const { t } = useI18n();
const $t = t;

const createStore = useCreateStore();
const { lineSize, lineStyle, lineColor, arrowEnding, activePage, lineText, font, type } = storeToRefs(createStore);
let configuration = inject<any>('configuration');
const lineStyles = configuration.style.lineStyles;
const maxLineSize = configuration.style.maxLineSize;
const lineColors = configuration.style.lineColors;
const lineArrows = configuration.style.lineArrows;
const timelineLineColors = configuration.style.timelineLineColors;

const setActivePage = (value: string)=>{
    activePage.value = value;
}

const getFontFamily = computed(()=>{
    let localFont;
    switch(font.value){
        case('arial'):
            localFont = "Arial, sans-serif";
            break;
        case('comic-neue'):
            localFont = "'Comic Neue', serif";
            break;
        case('courier'):
            localFont = "'Courier New', Courier, monospace";
            break;
        case('times-new-roman'):
            localFont = "'Times New Roman', 'Times New Roman', Times, serif";
            break;
        case('georgia'):
            localFont = "Georgia, serif";
            break;
        case('trebuchet-ms'):
            localFont = "'Trebuchet MS', sans-serif";
            break;
        case('helvetica'):
            localFont = "Helvetica, sans-serif";
            break;
        case('verdana'):
            localFont = "Verdana, sans-serif";
            break;
        default:
            localFont = '';
            break;
    }
    return localFont;
});


const computedMaxLineSize = computed(()=>{
    return type.value.toLowerCase()==="freeform"?maxLineSize:5;
});

const computedLineColors = computed(()=>{
    return type.value.toLowerCase()==="freeform"?lineColors:timelineLineColors;
})

</script>
<template>
    <div class="flex flex-col h-full justify-between">
        <div class="flex flex-col md:flex-row w-full">
            <div class="sm:w-3/5" >
                <div class="px-4">
                    <div class="w-40"><Range :label="$t('adjustPanel.lineLook.strength')" :min="1" :max="computedMaxLineSize" :step="1" v-model="lineSize" /></div>
                    <BoxSelector :label="$t('adjustPanel.lineLook.style')" v-model="lineStyle" :items="lineStyles" :identifier="itemEnum.NAME" type="lines" v-if="type.toLowerCase()==='freeform'"/>
                    <BoxSelector :label="$t('adjustPanel.color')" v-model="lineColor" :items="computedLineColors" :identifier="itemEnum.VALUE" type="colors"/>
                    <RadioButtonsGroup :label="$t('adjustPanel.lineLook.ending')" v-model="arrowEnding" :items="lineArrows" v-if="type.toLowerCase()==='freeform'"/>
                </div>
            </div>
            <div class="md:w-2/5 p-4 pt-0 h-[330px] flex grow w-full">
                <PreviewLine backgroundColor="#ffffff" :color="lineColor" :size="lineSize" :dash="lineStyle === 'dotted'" :lineText="lineText" :ending="arrowEnding" :fontFamily="getFontFamily" />
            </div>
        </div>
        <div class="flex flex-row w-full justify-between">
            <div>
                <Button variant="cancel" @click="setActivePage('color')">
                    <i class="ri-arrow-left-s-line"></i>
                    <span class="uppercase">{{ $t('general.buttons.back') }}</span>
                </Button>
            </div>
            <div>
                <Button variant="confirm" @click="setActivePage('preview')">
                    <span class="uppercase">{{ $t('general.buttons.next') }}</span>
                    <i class="ri-arrow-right-s-line"></i>
                </Button>
            </div>
        </div>
    </div>
</template>